* nbr2_f11.11.do  table of observed vs predicted frequencies
* Table 11.13  Hilbe,JM, Negative Binomial Regression, 2 ed, Cambridge Univ Press
* Modified from code in Long and Freese (2006), Page 406
use mdvis, clear    
global xvars reform badh educ3 age3 

* NB2
qui nbreg numvisit reform badh educ3 age3 if numvis>0, nolog
prcounts pnb2, plot max(9)
lab var pnb2preq "Predicted NB2"
lab var pnb2obeq "Observed NB2"

* ZIP
qui zip numvisit $xvars, inflate($xvars) 
prcounts pzip, plot max(9)
lab var pzippreq "Predicted ZIP 

* ZINB
qui zinb numvisit $xvars, inflate($xvars) 
prcounts pzinb, plot max(9)
lab var pzinbpreq "Predicted ZINB

*  Differences
gen obs = pnb2obeq
gen dnb2 = obs - pnb2preq
lab var dnb2 "NB2 Diff"

gen dzip = obs - pzippreq
lab var dzip "ZIP Diff"

gen dzinb = obs - pzinbpreq
lab var dzinb "ZINB Diff"

graph twoway connected dnb2 dzip dzinb pnb2val, /// 
  ytitle(Observed-Predicted) ylab(-.10(.05).10) ///
  xlab(0(1)9) msymbol(0h Sh 0 S)




