* nb2ml_sim.ado  
* Table 9.6  Hilbe,JM, Negative Binomial Regression, 2 ed, Cambridge Univ Press
* x1=.75, x2=-1.25, _cons=2, alpha=0.5
program define nb2ml_sim, rclass
version 10
clear
set obs 50000
gen x1 = rnormal()
gen x2 = rnormal()
gen xb = 2 + 0.75*x1 - 1.25*x2
gen a = .5
gen ia = 1/a
gen exb = exp(xb)
gen xg = rgamma(ia, a)
gen xbg = exb * xg
gen nby = rpoisson(xbg)
glm nby x1 x2, nolog fam(nb ml)
return scalar sx1 = _b[x1]
return scalar sx2 = _b[x2]
return scalar sxc = _b[_cons]
return scalar pd  = e(dispers_p)
return scalar dd  = e(dispers_s)
return scalar _a = `e(a)'
end

* simulate mx1= r(sx1) mx2= r(sx2) mxc= r(sxc) pdis= r(pd) ddis = r(dd) alpha= r(_a), reps(100): nb2ml_sim
* sum
